Index: LMDZ6/branches/Amaury_dev/libf/phylmd/cv3_routines.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/cv3_routines.F90	(revision 5140)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/cv3_routines.F90	(revision 5141)
@@ -4634,169 +4591,169 @@
     END DO
   END DO
-!jyg<  (loops stop at nl)
-!!  DO i = nl + 1, nd
-!!    DO il = 1, ncum
-!!      dnwd0(il, i) = 0.
-!!    END DO
-!!  END DO
-!>jyg
-
-
-!jyg<
-!-----------------------------------------------------------
-           IF (.NOT.ok_optim_yield) THEN                  !|
-!-----------------------------------------------------------
-  DO i = 1, nl
-    DO il = 1, ncum
-      upwd(il, i) = 0.0
-      dnwd(il, i) = 0.0
-    END DO
-  END DO
-
-!!  DO i = 1, nl                                           ! useless; jyg
-!!    DO il = 1, ncum                                      ! useless; jyg
-!!      IF (i>=icb(il) .AND. i<=inb(il)) THEN              ! useless; jyg
-!!        upwd(il, i) = 0.0                                ! useless; jyg
-!!        dnwd(il, i) = 0.0                                ! useless; jyg
-!!      END IF                                             ! useless; jyg
-!!    END DO                                               ! useless; jyg
-!!  END DO                                                 ! useless; jyg
-
-  DO i = 1, nl
-    DO k = 1, nl
+  !jyg<  (loops stop at nl)
+  !!  DO i = nl + 1, nd
+  !!    DO il = 1, ncum
+  !!      dnwd0(il, i) = 0.
+  !!    END DO
+  !!  END DO
+  !>jyg
+
+
+  !jyg<
+  !-----------------------------------------------------------
+  IF (.NOT.ok_optim_yield) THEN                  !|
+    !-----------------------------------------------------------
+    DO i = 1, nl
       DO il = 1, ncum
-        up1(il, k, i) = 0.0
-        dn1(il, k, i) = 0.0
+        upwd(il, i) = 0.0
+        dnwd(il, i) = 0.0
       END DO
     END DO
-  END DO
-
-!yor! commented original
-!  DO i = 1, nl
-!    DO k = i, nl
-!      DO n = 1, i - 1
-!        DO il = 1, ncum
-!          IF (i>=icb(il) .AND. i<=inb(il) .AND. k<=inb(il)) THEN
-!            up1(il, k, i) = up1(il, k, i) + ment(il, n, k)
-!            dn1(il, k, i) = dn1(il, k, i) - ment(il, k, n)
-!          END IF
-!        END DO
-!      END DO
-!    END DO
-!  END DO
-!yor! replaced with
-  DO i = 1, nl
-    DO k = i, nl
-      DO n = 1, i - 1
+
+    !!  DO i = 1, nl                                           ! useless; jyg
+    !!    DO il = 1, ncum                                      ! useless; jyg
+    !!      IF (i>=icb(il) .AND. i<=inb(il)) THEN              ! useless; jyg
+    !!        upwd(il, i) = 0.0                                ! useless; jyg
+    !!        dnwd(il, i) = 0.0                                ! useless; jyg
+    !!      END IF                                             ! useless; jyg
+    !!    END DO                                               ! useless; jyg
+    !!  END DO                                                 ! useless; jyg
+
+    DO i = 1, nl
+      DO k = 1, nl
         DO il = 1, ncum
-          IF (i>=icb(il) .AND. k<=inb(il)) THEN ! yor ! as i always <= k
-             up1(il, k, i) = up1(il, k, i) + ment(il, n, k)
-          END IF
+          up1(il, k, i) = 0.0
+          dn1(il, k, i) = 0.0
         END DO
       END DO
     END DO
-  END DO
-  DO i = 1, nl
-    DO n = 1, i - 1
+
+    !yor! commented original
+    !  DO i = 1, nl
+    !    DO k = i, nl
+    !      DO n = 1, i - 1
+    !        DO il = 1, ncum
+    !          IF (i>=icb(il) .AND. i<=inb(il) .AND. k<=inb(il)) THEN
+    !            up1(il, k, i) = up1(il, k, i) + ment(il, n, k)
+    !            dn1(il, k, i) = dn1(il, k, i) - ment(il, k, n)
+    !          END IF
+    !        END DO
+    !      END DO
+    !    END DO
+    !  END DO
+    !yor! replaced with
+    DO i = 1, nl
+      DO k = i, nl
+        DO n = 1, i - 1
+          DO il = 1, ncum
+            IF (i>=icb(il) .AND. k<=inb(il)) THEN ! yor ! as i always <= k
+              up1(il, k, i) = up1(il, k, i) + ment(il, n, k)
+            END IF
+          END DO
+        END DO
+      END DO
+    END DO
+    DO i = 1, nl
+      DO n = 1, i - 1
+        DO k = i, nl
+          DO il = 1, ncum
+            IF (i>=icb(il) .AND. k<=inb(il)) THEN ! yor !  i always <= k
+              dn1(il, k, i) = dn1(il, k, i) - ment(il, k, n)
+            END IF
+          END DO
+        END DO
+      END DO
+    END DO
+    !yor! end replace
+
+    DO i = 1, nl
+      DO k = 1, nl
+        DO il = 1, ncum
+          IF (i>=icb(il)) THEN
+            IF (k>=i .AND. k<=(inb(il))) THEN
+              upwd(il, i) = upwd(il, i) + m(il, k)
+            END IF
+          ELSE
+            IF (k<i) THEN
+              upwd(il, i) = upwd(il, i) + cbmf(il) * wghti(il, k)
+            END IF
+          END IF
+          ! c        print *,'cbmf',il,i,k,cbmf(il),wghti(il,k)
+        END DO
+      END DO
+    END DO
+
+    DO i = 2, nl
       DO k = i, nl
         DO il = 1, ncum
-          IF (i>=icb(il) .AND. k<=inb(il)) THEN ! yor !  i always <= k
-             dn1(il, k, i) = dn1(il, k, i) - ment(il, k, n)
+          ! test         if (i.ge.icb(il).AND.i.le.inb(il).AND.k.le.inb(il)) THEN
+          IF (i<=inb(il) .AND. k<=inb(il)) THEN
+            upwd(il, i) = upwd(il, i) + up1(il, k, i)
+            dnwd(il, i) = dnwd(il, i) + dn1(il, k, i)
           END IF
+          ! c         print *,'upwd',il,i,k,inb(il),upwd(il,i),m(il,k),up1(il,k,i)
         END DO
       END DO
     END DO
-  END DO
-!yor! end replace 
-
-  DO i = 1, nl
-    DO k = 1, nl
-      DO il = 1, ncum
-        IF (i>=icb(il)) THEN
-          IF (k>=i .AND. k<=(inb(il))) THEN
-            upwd(il, i) = upwd(il, i) + m(il, k)
-          END IF
-        ELSE
-          IF (k<i) THEN
-            upwd(il, i) = upwd(il, i) + cbmf(il)*wghti(il, k)
-          END IF
-        END IF
-! c        print *,'cbmf',il,i,k,cbmf(il),wghti(il,k)
-      END DO
-    END DO
-  END DO
-
-  DO i = 2, nl
-    DO k = i, nl
-      DO il = 1, ncum
-! test         if (i.ge.icb(il).AND.i.le.inb(il).AND.k.le.inb(il)) THEN
-        IF (i<=inb(il) .AND. k<=inb(il)) THEN
-          upwd(il, i) = upwd(il, i) + up1(il, k, i)
-          dnwd(il, i) = dnwd(il, i) + dn1(il, k, i)
-        END IF
-! c         print *,'upwd',il,i,k,inb(il),upwd(il,i),m(il,k),up1(il,k,i)
-      END DO
-    END DO
-  END DO
-
-
-!!!!      DO il=1,ncum
-!!!!      do i=icb(il),inb(il)
-!!!!
-!!!!      upwd(il,i)=0.0
-!!!!      dnwd(il,i)=0.0
-!!!!      do k=i,inb(il)
-!!!!      up1=0.0
-!!!!      dn1=0.0
-!!!!      do n=1,i-1
-!!!!      up1=up1+ment(il,n,k)
-!!!!      dn1=dn1-ment(il,k,n)
-!!!!      enddo
-!!!!      upwd(il,i)=upwd(il,i)+m(il,k)+up1
-!!!!      dnwd(il,i)=dnwd(il,i)+dn1
-!!!!      enddo
-!!!!      enddo
-!!!!
-!!!!      ENDDO
-
-!!  DO i = 1, nlp
-!!    DO il = 1, ncum
-!!      ma(il, i) = 0
-!!    END DO
-!!  END DO
-!!
-!!  DO i = 1, nl
-!!    DO j = i, nl
-!!      DO il = 1, ncum
-!!        ma(il, i) = ma(il, i) + m(il, j)
-!!      END DO
-!!    END DO
-!!  END DO
-
-!jyg<  (loops stop at nl)
-!!  DO i = nl + 1, nd
-!!    DO il = 1, ncum
-!!      ma(il, i) = 0.
-!!    END DO
-!!  END DO
-!>jyg
-
-!!  DO i = 1, nl
-!!    DO il = 1, ncum
-!!      IF (i<=(icb(il)-1)) THEN
-!!        ma(il, i) = 0
-!!      END IF
-!!    END DO
-!!  END DO
-
-!-----------------------------------------------------------
-        ENDIF !(.NOT.ok_optim_yield)                      !|
-!-----------------------------------------------------------
-!>jyg
-
-! ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
-! determination de la variation de flux ascendant entre
-! deux niveau non dilue mip
-! ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
+
+
+    !!!!      DO il=1,ncum
+    !!!!      do i=icb(il),inb(il)
+    !!!!
+    !!!!      upwd(il,i)=0.0
+    !!!!      dnwd(il,i)=0.0
+    !!!!      do k=i,inb(il)
+    !!!!      up1=0.0
+    !!!!      dn1=0.0
+    !!!!      do n=1,i-1
+    !!!!      up1=up1+ment(il,n,k)
+    !!!!      dn1=dn1-ment(il,k,n)
+    !!!!      enddo
+    !!!!      upwd(il,i)=upwd(il,i)+m(il,k)+up1
+    !!!!      dnwd(il,i)=dnwd(il,i)+dn1
+    !!!!      enddo
+    !!!!      enddo
+    !!!!
+    !!!!      ENDDO
+
+    !!  DO i = 1, nlp
+    !!    DO il = 1, ncum
+    !!      ma(il, i) = 0
+    !!    END DO
+    !!  END DO
+    !!
+    !!  DO i = 1, nl
+    !!    DO j = i, nl
+    !!      DO il = 1, ncum
+    !!        ma(il, i) = ma(il, i) + m(il, j)
+    !!      END DO
+    !!    END DO
+    !!  END DO
+
+    !jyg<  (loops stop at nl)
+    !!  DO i = nl + 1, nd
+    !!    DO il = 1, ncum
+    !!      ma(il, i) = 0.
+    !!    END DO
+    !!  END DO
+    !>jyg
+
+    !!  DO i = 1, nl
+    !!    DO il = 1, ncum
+    !!      IF (i<=(icb(il)-1)) THEN
+    !!        ma(il, i) = 0
+    !!      END IF
+    !!    END DO
+    !!  END DO
+
+    !-----------------------------------------------------------
+  ENDIF !(.NOT.ok_optim_yield)                      !|
+  !-----------------------------------------------------------
+  !>jyg
+
+  ! ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
+  ! determination de la variation de flux ascendant entre
+  ! deux niveau non dilue mip
+  ! ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
 
   DO i = 1, nl
@@ -4806,38 +4763,38 @@
   END DO
 
-!jyg<  (loops stop at nl)
-!!  DO i = nl + 1, nd
-!!    DO il = 1, ncum
-!!      mip(il, i) = 0.
-!!    END DO
-!!  END DO
-!>jyg
-
-
-! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
-! icb represente de niveau ou se trouve la
-! base du nuage , et inb le top du nuage
-! ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
-
-!!  DO i = 1, nd                                  ! unused . jyg
-!!    DO il = 1, ncum                             ! unused . jyg
-!!      mke(il, i) = upwd(il, i) + dnwd(il, i)    ! unused . jyg
-!!    END DO                                      ! unused . jyg
-!!  END DO                                        ! unused . jyg
-
-!!  DO i = 1, nd                                                                 ! unused . jyg
-!!    DO il = 1, ncum                                                            ! unused . jyg
-!!      rdcp = (rrd*(1.-rr(il,i))-rr(il,i)*rrv)/(cpd*(1.-rr(il,i))+rr(il,i)*cpv) ! unused . jyg
-!!      tls(il, i) = t(il, i)*(1000.0/p(il,i))**rdcp                             ! unused . jyg
-!!      tps(il, i) = tp(il, i)                                                   ! unused . jyg
-!!    END DO                                                                     ! unused . jyg
-!!  END DO                                                                       ! unused . jyg
-
-
-! *** diagnose the in-cloud mixing ratio   ***                       ! cld
-! ***           of condensed water         ***                       ! cld
-!! cld                                                               
-                                                                     
-  DO i = 1, nl+1                                                     ! cld
+  !jyg<  (loops stop at nl)
+  !!  DO i = nl + 1, nd
+  !!    DO il = 1, ncum
+  !!      mip(il, i) = 0.
+  !!    END DO
+  !!  END DO
+  !>jyg
+
+
+  ! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
+  ! icb represente de niveau ou se trouve la
+  ! base du nuage , et inb le top du nuage
+  ! ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
+
+  !!  DO i = 1, nd                                  ! unused . jyg
+  !!    DO il = 1, ncum                             ! unused . jyg
+  !!      mke(il, i) = upwd(il, i) + dnwd(il, i)    ! unused . jyg
+  !!    END DO                                      ! unused . jyg
+  !!  END DO                                        ! unused . jyg
+
+  !!  DO i = 1, nd                                                                 ! unused . jyg
+  !!    DO il = 1, ncum                                                            ! unused . jyg
+  !!      rdcp = (rrd*(1.-rr(il,i))-rr(il,i)*rrv)/(cpd*(1.-rr(il,i))+rr(il,i)*cpv) ! unused . jyg
+  !!      tls(il, i) = t(il, i)*(1000.0/p(il,i))**rdcp                             ! unused . jyg
+  !!      tps(il, i) = tp(il, i)                                                   ! unused . jyg
+  !!    END DO                                                                     ! unused . jyg
+  !!  END DO                                                                       ! unused . jyg
+
+
+  ! *** diagnose the in-cloud mixing ratio   ***                       ! cld
+  ! ***           of condensed water         ***                       ! cld
+  !! cld
+
+  DO i = 1, nl + 1                                                     ! cld
     DO il = 1, ncum                                                  ! cld
       mac(il, i) = 0.0                                               ! cld
@@ -4847,9 +4804,9 @@
     END DO                                                           ! cld
   END DO                                                             ! cld
-                                                                     
+
   DO i = minorig, nl                                                 ! cld
     DO k = i + 1, nl + 1                                             ! cld
       DO il = 1, ncum                                                ! cld
-        IF (i<=inb(il) .AND. k<=(inb(il)+1) .AND. iflag(il)<=1) THEN ! cld
+        IF (i<=inb(il) .AND. k<=(inb(il) + 1) .AND. iflag(il)<=1) THEN ! cld
           mac(il, i) = mac(il, i) + m(il, k)                         ! cld
         END IF                                                       ! cld
@@ -4861,8 +4818,8 @@
     DO j = 1, i                                                      ! cld
       DO il = 1, ncum                                                ! cld
-        IF (i>=icb(il) .AND. i<=(inb(il)-1) &                        ! cld
-            .AND. j>=icb(il) .AND. iflag(il)<=1) THEN                ! cld
-          sax(il, i) = sax(il, i) + rrd*(tvp(il,j)-tv(il,j)) &       ! cld
-            *(ph(il,j)-ph(il,j+1))/p(il, j)                          ! cld
+        IF (i>=icb(il) .AND. i<=(inb(il) - 1) &                        ! cld
+                .AND. j>=icb(il) .AND. iflag(il)<=1) THEN                ! cld
+          sax(il, i) = sax(il, i) + rrd * (tvp(il, j) - tv(il, j)) &       ! cld
+                  * (ph(il, j) - ph(il, j + 1)) / p(il, j)                          ! cld
         END IF                                                       ! cld
       END DO                                                         ! cld
@@ -4872,73 +4829,71 @@
   DO i = 1, nl                                                       ! cld
     DO il = 1, ncum                                                  ! cld
-      IF (i>=icb(il) .AND. i<=(inb(il)-1) &                          ! cld
-          .AND. sax(il,i)>0.0 .AND. iflag(il)<=1) THEN               ! cld
-        wa(il, i) = sqrt(2.*sax(il,i))                               ! cld
+      IF (i>=icb(il) .AND. i<=(inb(il) - 1) &                          ! cld
+              .AND. sax(il, i)>0.0 .AND. iflag(il)<=1) THEN               ! cld
+        wa(il, i) = sqrt(2. * sax(il, i))                               ! cld
       END IF                                                         ! cld
     END DO                                                           ! cld
-  END DO  
-                                                           ! cld
-  DO i = 1, nl  
-
-! 14/01/15 AJ je remets les parties manquantes cf JYG
-! Initialize sument to 0
-
-    DO il = 1,ncum
-     sument(il) = 0.
+  END DO
+  ! cld
+  DO i = 1, nl
+
+    ! 14/01/15 AJ je remets les parties manquantes cf JYG
+    ! Initialize sument to 0
+
+    DO il = 1, ncum
+      sument(il) = 0.
     ENDDO
 
-! Sum mixed mass fluxes in sument
-
-    DO k = 1,nl
-      DO il = 1,ncum
+    ! Sum mixed mass fluxes in sument
+
+    DO k = 1, nl
+      DO il = 1, ncum
         IF  (k<=inb(il) .AND. i<=inb(il) .AND. iflag(il)<=1) THEN   ! cld
-          sument(il) =sument(il) + abs(ment(il,k,i))
-          detrain(il,i) = detrain(il,i) + abs(ment(il,k,i))*(qdet(il,k,i) - rr(il,i))*(qdet(il,k,i) - rr(il,i)) ! Louis terme de détrainement dans le bilan de variance
+          sument(il) = sument(il) + abs(ment(il, k, i))
+          detrain(il, i) = detrain(il, i) + abs(ment(il, k, i)) * (qdet(il, k, i) - rr(il, i)) * (qdet(il, k, i) - rr(il, i)) ! Louis terme de détrainement dans le bilan de variance
         ENDIF
       ENDDO     ! il
     ENDDO       ! k
 
-! 14/01/15 AJ delta n'a rien à faire là...
+    ! 14/01/15 AJ delta n'a rien à faire là...
     DO il = 1, ncum                                                  ! cld
-!!      IF (wa(il,i)>0.0 .AND. iflag(il)<=1) &                         ! cld
-!!        siga(il, i) = mac(il, i)/(coefw_cld_cv*wa(il, i)) &          ! cld
-!!        *rrd*tvp(il, i)/p(il, i)/100.                                ! cld
-!!
-!!      siga(il, i) = min(siga(il,i), 1.0)                             ! cld
+      !!      IF (wa(il,i)>0.0 .AND. iflag(il)<=1) &                         ! cld
+      !!        siga(il, i) = mac(il, i)/(coefw_cld_cv*wa(il, i)) &          ! cld
+      !!        *rrd*tvp(il, i)/p(il, i)/100.                                ! cld
+      !!
+      !!      siga(il, i) = min(siga(il,i), 1.0)                             ! cld
       sigaq = 0.
-      IF (wa(il,i)>0.0 .AND. iflag(il)<=1)  THEN                     ! cld
-        siga(il, i) = mac(il, i)/(coefw_cld_cv*wa(il, i)) &          ! cld
-                     *rrd*tvp(il, i)/p(il, i)/100.                   ! cld
-        siga(il, i) = min(siga(il,i), 1.0)                           ! cld
-        sigaq = siga(il,i)*qta(il,i-1)                               ! cld
+      IF (wa(il, i)>0.0 .AND. iflag(il)<=1)  THEN                     ! cld
+        siga(il, i) = mac(il, i) / (coefw_cld_cv * wa(il, i)) &          ! cld
+                * rrd * tvp(il, i) / p(il, i) / 100.                   ! cld
+        siga(il, i) = min(siga(il, i), 1.0)                           ! cld
+        sigaq = siga(il, i) * qta(il, i - 1)                               ! cld
       ENDIF
 
-! IM cf. FH 
-! 14/01/15 AJ ne correspond pas à ce qui a été codé par JYG et SB
-                                                         
+      ! IM cf. FH
+      ! 14/01/15 AJ ne correspond pas à ce qui a été codé par JYG et SB
+
       IF (iflag_clw==0) THEN                                         ! cld
-        qcondc(il, i) = siga(il, i)*clw(il, i)*(1.-ep(il,i)) &       ! cld
-          +(1.-siga(il,i))*qcond(il, i)                              ! cld
-
-
-        sigment(il,i)=sument(il)*tau_cld_cv/(ph(il,i)-ph(il,i+1))    ! cld
-        sigment(il, i) = min(1.e-4+sigment(il,i), 1.0 - siga(il,i))  ! cld
-!!        qtc(il, i) = (siga(il,i)*qta(il,i-1)+sigment(il,i)*qtment(il,i)) & ! cld
-        qtc(il, i) = (sigaq+sigment(il,i)*qtment(il,i)) & ! cld
-                     /(siga(il,i)+sigment(il,i))                     ! cld
-        sigt(il,i) = sigment(il, i) + siga(il, i)
-
-!        qtc(il, i) = siga(il,i)*qta(il,i-1)+(1.-siga(il,i))*qtment(il,i) ! cld
-!     PRINT*,'BIGAUSSIAN CONV',siga(il,i),sigment(il,i),qtc(il,i)
-      		
+        qcondc(il, i) = siga(il, i) * clw(il, i) * (1. - ep(il, i)) &       ! cld
+                + (1. - siga(il, i)) * qcond(il, i)                              ! cld
+
+        sigment(il, i) = sument(il) * tau_cld_cv / (ph(il, i) - ph(il, i + 1))    ! cld
+        sigment(il, i) = min(1.e-4 + sigment(il, i), 1.0 - siga(il, i))  ! cld
+        !!        qtc(il, i) = (siga(il,i)*qta(il,i-1)+sigment(il,i)*qtment(il,i)) & ! cld
+        qtc(il, i) = (sigaq + sigment(il, i) * qtment(il, i)) & ! cld
+                / (siga(il, i) + sigment(il, i))                     ! cld
+        sigt(il, i) = sigment(il, i) + siga(il, i)
+
+        !        qtc(il, i) = siga(il,i)*qta(il,i-1)+(1.-siga(il,i))*qtment(il,i) ! cld
+        !     PRINT*,'BIGAUSSIAN CONV',siga(il,i),sigment(il,i),qtc(il,i)
+
       ELSE IF (iflag_clw==1) THEN                                    ! cld
         qcondc(il, i) = qcond(il, i)                                 ! cld
-        qtc(il,i) = qtment(il,i)                                     ! cld
+        qtc(il, i) = qtment(il, i)                                     ! cld
       END IF                                                         ! cld
 
     END DO                                                           ! cld
   END DO
-! PRINT*,'cv3_yield fin'
-
+  ! PRINT*,'cv3_yield fin'
 
 END SUBROUTINE cv3_yield
@@ -4946,35 +4901,37 @@
 !AC! et !RomP >>>
 SUBROUTINE cv3_tracer(nloc, len, ncum, nd, na, &
-                      ment, sigij, da, phi, phi2, d1a, dam, &
-                      ep, Vprecip, elij, clw, epmlmMm, eplaMm, &
-                      icb, inb)
+        ment, sigij, da, phi, phi2, d1a, dam, &
+        ep, Vprecip, elij, clw, epmlmMm, eplaMm, &
+        icb, inb)
+
+  USE lmdz_cv3param
+
   IMPLICIT NONE
 
-  include "cv3param.h"
-
-!inputs:
-  INTEGER, INTENT (IN)                               :: ncum, nd, na, nloc, len
-  INTEGER, DIMENSION (len), INTENT (IN)              :: icb, inb
-  REAL, DIMENSION (len, na, na), INTENT (IN)         :: ment, sigij, elij
-  REAL, DIMENSION (len, nd), INTENT (IN)             :: clw
-  REAL, DIMENSION (len, na), INTENT (IN)             :: ep
-  REAL, DIMENSION (len, nd+1), INTENT (IN)           :: Vprecip
-!ouputs:
-  REAL, DIMENSION (len, na, na), INTENT (OUT)        :: phi, phi2, epmlmMm
-  REAL, DIMENSION (len, na), INTENT (OUT)            :: da, d1a, dam, eplaMm
-
-! variables pour tracer dans precip de l'AA et des mel
-!local variables:
+
+  !inputs:
+  INTEGER, INTENT (IN) :: ncum, nd, na, nloc, len
+  INTEGER, DIMENSION (len), INTENT (IN) :: icb, inb
+  REAL, DIMENSION (len, na, na), INTENT (IN) :: ment, sigij, elij
+  REAL, DIMENSION (len, nd), INTENT (IN) :: clw
+  REAL, DIMENSION (len, na), INTENT (IN) :: ep
+  REAL, DIMENSION (len, nd + 1), INTENT (IN) :: Vprecip
+  !ouputs:
+  REAL, DIMENSION (len, na, na), INTENT (OUT) :: phi, phi2, epmlmMm
+  REAL, DIMENSION (len, na), INTENT (OUT) :: da, d1a, dam, eplaMm
+
+  ! variables pour tracer dans precip de l'AA et des mel
+  !local variables:
   INTEGER i, j, k
   REAL epm(nloc, na, na)
 
-! variables d'Emanuel : du second indice au troisieme
-! --->    tab(i,k,j) -> de l origine k a l arrivee j
-! ment, sigij, elij
-! variables personnelles : du troisieme au second indice
-! --->    tab(i,j,k) -> de k a j
-! phi, phi2
-
-! initialisations
+  ! variables d'Emanuel : du second indice au troisieme
+  ! --->    tab(i,k,j) -> de l origine k a l arrivee j
+  ! ment, sigij, elij
+  ! variables personnelles : du troisieme au second indice
+  ! --->    tab(i,j,k) -> de k a j
+  ! phi, phi2
+
+  ! initialisations
 
   da(:, :) = 0.
@@ -4987,21 +4944,20 @@
   phi2(:, :, :) = 0.
 
-! fraction deau condensee dans les melanges convertie en precip : epm
-! et eau condensée précipitée dans masse d'air saturé : l_m*dM_m/dzdz.dzdz
+  ! fraction deau condensee dans les melanges convertie en precip : epm
+  ! et eau condensée précipitée dans masse d'air saturé : l_m*dM_m/dzdz.dzdz
   DO j = 1, nl
     DO k = 1, nl
       DO i = 1, ncum
-        IF (k>=icb(i) .AND. k<=inb(i) .AND. & 
-!!jyg              j.ge.k.AND.j.le.inb(i)) THEN
-!!jyg             epm(i,j,k)=1.-(1.-ep(i,j))*clw(i,j)/elij(i,k,j)
-            j>k .AND. j<=inb(i)) THEN
-          epm(i, j, k) = 1. - (1.-ep(i,j))*clw(i, j)/max(elij(i,k,j), 1.E-16)
-!!
-          epm(i, j, k) = max(epm(i,j,k), 0.0)
+        IF (k>=icb(i) .AND. k<=inb(i) .AND. &
+                !!jyg              j.ge.k.AND.j.le.inb(i)) THEN
+                !!jyg             epm(i,j,k)=1.-(1.-ep(i,j))*clw(i,j)/elij(i,k,j)
+                j>k .AND. j<=inb(i)) THEN
+          epm(i, j, k) = 1. - (1. - ep(i, j)) * clw(i, j) / max(elij(i, k, j), 1.E-16)
+          !!
+          epm(i, j, k) = max(epm(i, j, k), 0.0)
         END IF
       END DO
     END DO
   END DO
-
 
   DO j = 1, nl
@@ -5010,5 +4966,5 @@
         IF (k>=icb(i) .AND. k<=inb(i)) THEN
           eplaMm(i, j) = eplamm(i, j) + &
-                         ep(i, j)*clw(i, j)*ment(i, j, k)*(1.-sigij(i,j,k))
+                  ep(i, j) * clw(i, j) * ment(i, j, k) * (1. - sigij(i, j, k))
         END IF
       END DO
@@ -5020,5 +4976,5 @@
       DO i = 1, ncum
         IF (k>=icb(i) .AND. k<=inb(i) .AND. j<=inb(i)) THEN
-          epmlmMm(i, j, k) = epm(i, j, k)*elij(i, k, j)*ment(i, k, j)
+          epmlmMm(i, j, k) = epm(i, j, k) * elij(i, k, j) * ment(i, k, j)
         END IF
       END DO
@@ -5026,14 +4982,14 @@
   END DO
 
-! matrices pour calculer la tendance des concentrations dans cvltr.F90
+  ! matrices pour calculer la tendance des concentrations dans cvltr.F90
   DO j = 1, nl
     DO k = 1, nl
       DO i = 1, ncum
-        da(i, j) = da(i, j) + (1.-sigij(i,k,j))*ment(i, k, j)
-        phi(i, j, k) = sigij(i, k, j)*ment(i, k, j)
-        d1a(i, j) = d1a(i, j) + ment(i, k, j)*ep(i, k)*(1.-sigij(i,k,j))
+        da(i, j) = da(i, j) + (1. - sigij(i, k, j)) * ment(i, k, j)
+        phi(i, j, k) = sigij(i, k, j) * ment(i, k, j)
+        d1a(i, j) = d1a(i, j) + ment(i, k, j) * ep(i, k) * (1. - sigij(i, k, j))
         IF (k<=j) THEN
-          dam(i, j) = dam(i, j) + ment(i, k, j)*epm(i, k, j)*(1.-ep(i,k))*(1.-sigij(i,k,j))
-          phi2(i, j, k) = phi(i, j, k)*epm(i, j, k)
+          dam(i, j) = dam(i, j) + ment(i, k, j) * epm(i, k, j) * (1. - ep(i, k)) * (1. - sigij(i, k, j))
+          phi2(i, j, k) = phi(i, j, k) * epm(i, j, k)
         END IF
       END DO
@@ -5041,24 +4997,24 @@
   END DO
 
-
 END SUBROUTINE cv3_tracer
 !AC! et !RomP <<<
 
 SUBROUTINE cv3_uncompress(nloc, len, ncum, nd, ntra, idcum, &
-                          iflag, &
-                          precip, sig, w0, &
-                          ft, fq, fu, fv, ftra, &
-                          Ma, upwd, dnwd, dnwd0, qcondc, wd, cape, &
-                          epmax_diag, & ! epmax_cape
-                          iflag1, &
-                          precip1, sig1, w01, &
-                          ft1, fq1, fu1, fv1, ftra1, &
-                          Ma1, upwd1, dnwd1, dnwd01, qcondc1, wd1, cape1, &
-                          epmax_diag1) ! epmax_cape
+        iflag, &
+        precip, sig, w0, &
+        ft, fq, fu, fv, ftra, &
+        Ma, upwd, dnwd, dnwd0, qcondc, wd, cape, &
+        epmax_diag, & ! epmax_cape
+        iflag1, &
+        precip1, sig1, w01, &
+        ft1, fq1, fu1, fv1, ftra1, &
+        Ma1, upwd1, dnwd1, dnwd01, qcondc1, wd1, cape1, &
+        epmax_diag1) ! epmax_cape
+
+  USE lmdz_cv3param
+
   IMPLICIT NONE
 
-  include "cv3param.h"
-
-!inputs:
+  !inputs:
   INTEGER len, ncum, nd, ntra, nloc
   INTEGER idcum(nloc)
@@ -5074,5 +5030,5 @@
   REAL epmax_diag(nloc)
 
-!outputs:
+  !outputs:
   INTEGER iflag1(len)
   REAL precip1(len)
@@ -5086,5 +5042,5 @@
   REAL epmax_diag1(len) ! epmax_cape
 
-!local variables:
+  !local variables:
   INTEGER i, k, j
 
@@ -5094,5 +5050,5 @@
     wd1(idcum(i)) = wd(i)
     cape1(idcum(i)) = cape(i)
-    epmax_diag1(idcum(i))=epmax_diag(i) ! epmax_cape
+    epmax_diag1(idcum(i)) = epmax_diag(i) ! epmax_cape
   END DO
 
